#! /usr/bin/env python

# ls_dyndns.py
# 10/27/00
# bgriggs@pobox.com
# http://greenman.dyndns.org/ls_dyndns
# copyright 2000, no rights reserved.  
# 01/05/2004 Changes made by Sam Land http://www.dyndnsservices.com
# do with as you will.  if you add something neat send it to me so i
# can share.  this script was written in the true spirit of python.
# it addresses a need and it was addressed very quickly.  the script
# is not pretty but it is functional.  it is also free.  i hope it 
# brings you as much resolution as it did me... ;)  - bad joke

# this script is friendly!  it does not update unless necessary.


# imports
import socket
import base64
import re
import sys
import time
import string
import httplib

# general vars - dont change
agentvers = 'ls_dyndns.py/1.06 bgriggs@pobox.com'
force = 0
lastip = '0.0.0.0'
error = 0



# =========== CHANGEABLE VARIABLES IN THIS BLOCK =============================
# this could reside in a file but this is a quick hack...
# just wanted to provide enough flexibility to make the script useful to 
# everyone.  

# linksys router vars - changeable
routerlanip = '192.168.1.6'
passwd_ls = '01nyet'

# DDNS vars - change me!
# your user name
username = 'sam' 

#your DDNS passwd
passwd_dd = 'nxazqq' 

# log file location to verify update status
logfile = 'ls_dydns_log.html'

# host = domain name of web site
dnshost = 'localhost'


# =========== END CHANGEABLE VARIABLES =======================================

# =========== function definitions =======================================

def SendRequestGetResponse(host, req, uname, passwd):
       	"""Wrapper for httplib routines; takes hostname and request string,
	returns response string
	"""
	response = ''
	h = httplib.HTTP(host)                   
	h.putrequest('GET', req)                 
	h.putheader('Host', host)                     
	h.putheader('User-agent', agentvers) 
        auth = base64.encodestring (uname + ':' + passwd)     
	h.putheader('Authorization', 'Basic %s' % auth)
	h.endheaders() 
	returncode, returnmsg, headers = h.getreply()
	if returncode == 200:  #OK
        	f = h.getfile()
        	response = f.read()
	else:
		print '{*}Error %d connecting to %s\n' % (returncode,  host) 
	return response
	# put error checking here?

# =========== end function definitions =======================================


# get the current time
ct_time = time.localtime(time.time())

# format time string
currenttime = time.strftime('Date: %m %d, %Y\nTime:%H:%M:%S', ct_time) 


try:
	if sys.argv[1] == '-f':
		force = 1
		print 'Force switch present.'
	else:
		print 'Force switch missing.'

except:
	print 'Force switch missing.'

# reading last IP processed
try:
	fileh = open ('lastip.dat', 'r')
	lastip = fileh.readline()
	error = fileh.readline()
	fileh.close()
except:
	print "First time script has run! Forcing update!"
	force = 1

# a lil regex magic here.  find the ip addresses
ip = re.compile ('\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}')

# =========== BEGIN LINKSYS ROUTER SECTION ===================================

request = '/Status.htm \n' \
        + 'Authorization: Basic ' \
        + base64.encodestring (' ' + ':' + passwd_ls) + '\n\n'

resp = SendRequestGetResponse(routerlanip, request,username,passwd_ls)


# locate the ips (8 total, we want the third)
routerip = ip.findall(resp)

# =========== END LINKSYS ROUTER SECTION =====================================


print 'Router IP: %s' % (routerip[2])
print 'Last recorded IP: %s' % (lastip)


if force:
	lastip = '0.0.0.0'

# check to see if the IP has changed - if not, record this in log file
if routerip[2] == lastip:
	print 'No update needed.\n'
	
	# open the log file
	newhtml = open (logfile, 'w')
	
	# write to log file
	newhtml.write('<HEAD><TITLE>No update necessary!</TITLE></HEAD><BODY>\n')
	newhtml.write('<H2>ls_dyndns.py v1.06 report:</H2>\n')
	newhtml.write('<H3>No updates were necessary.  Your current IP address was updated</H3>\n')
	newhtml.write('<H3>') 
	newhtml.write(currenttime)
	newhtml.write('</H3>\n')
	newhtml.write('<H3>Current IP address: ') 
	newhtml.write(lastip)
	newhtml.write('</H3>\n')
else:

# =========== BEGIN DDNS SECTION (WRITE) ===================================


	if error == 'ERROR':
		print 'Error Condition from the DDNS Server preventing the continued use of this script! Read log.'

	else:
		# the ip has changed so let's update it at the DDNS Server
		print 'Updating...\n'

		# format the request for the page


                request = '/dnsman.asp?wci=UpdateHost&UserID=' + username + '&Password=' + passwd_dd +'&ip=' + routerip[2]


		resp = SendRequestGetResponse(dnshost, request, '', '')

		respy = string.split(resp)

		newhtml = open (logfile, 'w')
		fileh = open ('lastip.dat', 'w')

		
		if (respy[0] == 'Update was Successful'):
			# write the lastip
			fileh.write(respy[1])
			# write log
			newhtml.write('<HEAD><TITLE>Update for performed!</TITLE></HEAD><BODY>\n')
			newhtml.write('<H2>ls_dyndns.py v1.06 report:</H2>\n')
			newhtml.write('<H3>Your current IP address was updated</H3>\n')
			newhtml.write('<H3>') 
			newhtml.write(currenttime)
			newhtml.write('</H3>\n')
			newhtml.write('<H3>Current IP address: ') 
			newhtml.write(respy[1])
			newhtml.write('</H3>\n')
			newhtml.write('<H3>DDNS return code: ') 
			newhtml.write(respy[0])
			newhtml.write('</H3>\n')
	
		elif (respy[0] == 'Primary Record Not Found' or 
                        respy[0] == 'Bad UserID or Password' or	
                        respy[0] == 'Your account is suspended for abuse' or
			respy[0] == 'This Domain is Disabled'):
			# write the lastip
			fileh.write(lastip)
			fileh.write('\n')
			fileh.write('ERROR')
			# write log
			newhtml.write('<HEAD><TITLE>THE DDNS SERVER HAS RETURNED AN ERROR!</TITLE></HEAD><BODY>\n')
			newhtml.write('<H2>ls_dyndns.py v1.06 report:</H2>\n')
			newhtml.write('<H3>The DDNS server has returned an error!  Please follow the instructions provided below.</H3>\n')
			newhtml.write('<H3>') 
			newhtml.write(currenttime)
			newhtml.write('</H3>\n')
			newhtml.write('<H3>Error: ') 
			newhtml.write(respy[0])
			newhtml.write('</H3>\n')
			newhtml.write('<H3>Extended error code: ') 
			if len(respy) > 1:
				newhtml.write(respy[1])
			else:
				newhtml.write('none')
			
			newhtml.write('</H3>\n')
			newhtml.write('<H3>Each error code is explained below - follow directions provided.</H3>\n')
			newhtml.write('<H3>   </H3>\n')
			newhtml.write("""<p><b>badsys</b> - system parameter not valid. Bad update format - contact
client author. </p>
<p><b>Your registration period has expired</b> - you need to register for service. Your registration period has expired </p>
<p><b>Primary Record Not Found</b> - you need to define host properly. the DDNS server does not know about
your hostname. perhaps create a host record! </p>
<p><b>Bad UserID or Password</b> - You have supplied a bad user name or password.. </p>
<p><b>Your account is suspended for abuse</b> - your account has been deactivated due to abuse. you are
probably running ls_dyndns with the -f option always. STOP. </p>
<p><b>This Domain is Disabled</b> - Your domain has been disabled. </p>
<p><i>All of these errors cause the script to disable itself! You must delete
the lastip.dat file to reenable ls_dyndns.py.</i></p>""")


		else:
			newhtml.write('<HEAD><TITLE>AHHHH!  mAJOr eRROR cONDItion!  EmAIL aUTHOR!!</TITLE></HEAD><BODY>\n')
			newhtml.write('<H2>ls_dyndns.py v1.06 report:</H2>\n')
			newhtml.write('<H3>AHHHH!  mAJOr eRROR cONDItion!  EmAIL aUTHOR!!</H3>\n')

# the end
